/*------------------------------------------------*/
/* FFTEST : A test program for FFT module         */
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "suart.h"		/* Defines for using Software UART module (Debugging via AVRSP-COM) */
#include "ffft.h"		/* Defines for using Fixed-point FFT module */

#define	SYSCLK		16000000

/*------------------------------------------------*/
/* Global variables                               */
char pool[16];	/* Console input buffer */

int16_t capture[FFT_N];			/* Wave capturing buffer */
complex_t bfly_buff[FFT_N];		/* FFT buffer */
uint16_t spektrum[FFT_N/2];		/* Spectrum output buffer */

/*------------------------------------------------*/
/* Capture waveform                               */
void capture_wave (int16_t *buffer, uint16_t count)
{
	ADMUX = _BV(REFS0)|_BV(ADLAR)|_BV(MUX2)|_BV(MUX1)|_BV(MUX0);	// channel

	do {
		ADCSRA = _BV(ADEN)|_BV(ADSC)|_BV(ADIF)|_BV(ADPS2)|_BV(ADPS1);
		while(bit_is_clear(ADCSRA, ADIF));
		*buffer++ = ADC - 32768;
	} while(--count);

	ADCSRA = 0;
}
